package org.dromara.inspection.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.inspection.domain.bo.ArStepBo;
import org.dromara.inspection.domain.vo.ArStepTreeVo;
import org.dromara.inspection.domain.vo.ArStepVo;

import java.util.Collection;
import java.util.List;

/**
 * 巡检步骤Service接口
 *
 * @author Lion Li
 * @date 2025-01-13
 */
public interface IArStepService {

    /**
     * 查询单个
     *
     * @return
     */
    ArStepVo queryById(Long id);

    /**
     * 查询列表
     */
    TableDataInfo<ArStepVo> queryPageList(ArStepBo bo, PageQuery pageQuery);

    /**
     * 查询列表
     */
    List<ArStepVo> queryList(ArStepBo bo);

    /**
     * 查询任务的步骤树
     *
     * @param taskId 任务ID
     * @return 步骤树列表
     */
    List<ArStepTreeVo> queryStepTree(Long taskId);

    /**
     * 根据新增业务对象插入巡检步骤
     *
     * @param bo 巡检步骤新增业务对象
     * @return
     */
    Boolean insertByBo(ArStepBo bo);

    /**
     * 根据编辑业务对象修改巡检步骤
     *
     * @param bo 巡检步骤编辑业务对象
     * @return
     */
    Boolean updateByBo(ArStepBo bo);

    /**
     * 校验并删除数据
     *
     * @param ids     主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);
}
